
**************************
**** GMM HIRM program ****
**************************

* `at'[1,1] : f
* `at'[1,2] : alph
* `at'[1,3] : ln(sigth)
* `at'[1,4] : arctanh(rhoth)
* `at'[1,5] : ln(yh)
* `at'[1,6] : alpw
* `at'[1,7] : zeta
* `at'[1,8] : ln(sigeta)
* `at'[1,9] : arctanh(rhoeta)
* `at'[1,10] : ln(yw)

program gmm_hirmexact

version 11
syntax varlist if, at(name)

quietly {
		
		tempvar f alph sigth rhoth yh alpw zeta sigeta rhoeta yw
		tempvar millsx millsd signu rhonu muhd muhx muwd muwx vhd vhx vwd vwx cvd cvx
				
		gen double `f' = `at'[1,1]
		gen double `alph' = `at'[1,2]
		gen double `sigth' = exp(`at'[1,3])
		gen double `rhoth' = tanh(`at'[1,4])
		gen double `yh' = exp(`at'[1,5])
		gen double `alpw' = `at'[1,6]
		gen double `zeta' = `at'[1,7]
		gen double `sigeta' = exp(`at'[1,8])
		gen double `rhoeta' = tanh(`at'[1,9])
		gen double `yw' = exp(`at'[1,10])
		
		gen double `millsx' = normalden(`f')/(1-normal(`f')) `if'
		gen double `millsd' = normalden(`f')/normal(`f') `if'
		
		gen double `signu' = (((`zeta'*`zeta')*(`sigth'*`sigth')) + (`sigeta'*`sigeta'))^0.5 `if'
		gen double `rhonu' = ((`zeta'*`sigth'*`rhoth') + (`sigeta'*`rhoeta'))/`signu' `if'
		
		gen double `muhd' = `alph' - ( `sigth'*`rhoth'*`millsd' ) `if'
		gen double `muhx' = `alph' + `yh' + ( `sigth'*`rhoth'*`millsx' ) `if'

		gen double `vhd' = (`sigth'*`sigth') * ( (1-(`rhoth'*`rhoth')) + ((`rhoth'*`rhoth')*(1 - (`millsd' * (`millsd' + `f')))) ) `if'
		gen double `vhx' = (`sigth'*`sigth') * ( (1-(`rhoth'*`rhoth')) + ((`rhoth'*`rhoth')*(1 - (`millsx' * (`millsx' - `f')))) ) `if'
	
		gen double `muwd' = `alpw' - ( ( (`zeta'*`sigth'*`rhoth') + (`sigeta'*`rhoeta') ) * `millsd' ) `if'
		gen double `muwx' = `alpw' + `yw' + ( ( (`zeta'*`sigth'*`rhoth') + (`sigeta'*`rhoeta') ) * `millsx' ) `if'

		gen double `vwd' = (`signu'*`signu') * ( (1-(`rhonu'*`rhonu')) + ((`rhonu'*`rhonu')*(1 - (`millsd' * (`millsd' + `f')))) ) `if'
		gen double `vwx' = (`signu'*`signu') * ( (1-(`rhonu'*`rhonu')) + ((`rhonu'*`rhonu')*(1 - (`millsx' * (`millsx' - `f')))) ) `if'

		gen double `cvd' = (`zeta'*`sigth'*`sigth') - (`signu'*`rhonu'*`sigth'*`rhoth'*`millsd'*(`millsd' + `f')) `if'
		gen double `cvx' = (`zeta'*`sigth'*`sigth') - (`signu'*`rhonu'*`sigth'*`rhoth'*`millsx'*(`millsx' - `f')) `if'
		
		local m1 : word 1 of `varlist'
		local m2 : word 2 of `varlist'
		local m3 : word 3 of `varlist'
		local m4 : word 4 of `varlist'
		local m5 : word 5 of `varlist'
		local m6 : word 6 of `varlist'
		local m7 : word 7 of `varlist'
		local m8 : word 8 of `varlist'
		local m9 : word 9 of `varlist'
		local m10 : word 10 of `varlist'
		
		replace `m1' = dv1 - ( 1 - normal(`f') ) `if'
		
		replace `m2' = dv2 - (`muhd' * normal(`f')) `if'
		replace `m3' = dv3 - (`muhx' * (1-normal(`f'))) `if'
		replace `m4' = dv4 - (((`vhd'*`vhd')+(`muhd'*`muhd')) * normal(`f')) `if'
		replace `m5' = dv5 - (((`vhx'*`vhx')+(`muhx'*`muhx')) * (1-normal(`f'))) `if'
		
		replace `m6' = dv6 - (`muwd' * normal(`f')) `if'
		replace `m7' = dv7 - (`muwx' * (1-normal(`f'))) `if'
		replace `m8' = dv8 - (((`vwd'*`vwd')+(`muwd'*`muwd')) * normal(`f')) `if'
		replace `m9' = dv9 - (((`vwx'*`vwx')+(`muwx'*`muwx')) * (1-normal(`f'))) `if'
		
		replace `m10' = dv10 - ((`cvd'+(`muhd'*`muwd')) * normal(`f')) `if'
		
}
end
