
#delimit;

*****************************************************;
**** This file prepares the geogaphy identifiers ****;
*****************************************************;

clear;
clear matrix;
set mem 8000m;
set matsize 800;
set more off;
capture log close;
global dofiles="/home/sjredding/himr-restud/stata/dofiles";
global logs="/home/sjredding/himr-restud/stata/logs";
global input="/data/sjredding/himr-input";
global data="/data/sjredding/himr-restud";

cd $dofiles;

* Clean up meso region concordance;
u $input/municip2meso.dta, clear;
so municipio;
sa $data/geography/munip-data-clean.dta, replace;

* The first two digits of the municipality code are the state;

clear;
insheet using $input/municnpj.csv;
gen double municipio=mod_municipio_nonmiss;
drop if municipio==.;
so municipio ano cnpj_radic;
merge municipio using $data/geography/munip-data-clean.dta;
tab _m;
keep if _m==3;
drop _m;
keep cnpj_radic mod_municipio_nonmiss meso ano;
ren ano year;
tostring mod_municipio_nonmiss, replace;
gen state=substr(mod_municipio_nonmiss,1,2);
drop if year<1986;
so cnpj_radic year;
sa $data/geography/stateidentifiers.dta,replace; 

foreach yr of numlist 1986(1)1998 {;
clear;
u $data/geography/stateidentifiers.dta;
keep if year==`yr';
drop year;
so cnpj_radic;
sa $data/geography/stateidentifiers-`yr'.dta,replace;
};
